Attribute VB_Name = "modStringHelper"
Option Explicit

Public Function FileExtension(ByVal sFileName As String) As String
'ACCEPT A FILENAME AND RETURN EVERYTHING AFTER THE LAST PERIOD (IT'S EXTENSION)
Dim s As String
Dim i As Integer

On Error GoTo FileExtension_ERR

    sFileName = RemoveQuotes(sFileName)
    For i = Len(sFileName) To 1 Step -1
        s = Mid(sFileName, i, 1)
        If s = "." Then Exit For
    Next
    
    FileExtension = ""
    If i > 0 Then
        FileExtension = UCase(Mid(sFileName, i + 1))
    End If
        
    Exit Function
    
FileExtension_ERR:
    Debug.Assert 0
    Debug.Print "FileExtension_ERR: " & Err.Description
    
End Function
Public Function GetFileName(ByVal sFilePath As String, Optional bNoExtension As Boolean) As String
'returns the directory that the file in the path resides in:
'ie . returns "Temp.dbf" from "c:\temp\table.dbf"

Dim i As Integer
Dim s As String
Dim iBeg As Integer
Dim sName As String

On Error GoTo GetFileName_ERR

    sFilePath = RemoveQuotes(sFilePath)
    For i = Len(sFilePath) To 1 Step -1
        s = Mid(sFilePath, i, 1)
    '   bail when when you get first backslash (s="\"):
        If s = "\" Then Exit For
    Next
    
    iBeg = i + 1
    
    If iBeg - 1 = Len(sFilePath) Then 'is a root dir
        sName = Left(sFilePath, 1)
    Else
        sName = Mid(sFilePath, iBeg)
    End If
    
    If bNoExtension Then
        If Len(sName) > 3 Then
    '   If there is an extension:
            If Mid(sName, Len(sName) - 3, 1) = "." Then
                If Len(sName) > 4 Then
                    GetFileName = Mid(sName, 1, Len(sName) - 4)
                Else
                    GetFileName = ""
                End If
            Else
                GetFileName = sName
            End If
        Else
    '   certainly no extension- filename is only 3 characters (ie. pat)
            GetFileName = sName
        End If
    Else
        GetFileName = sName
    End If
    

    Exit Function
    
    
GetFileName_ERR:
    Debug.Assert 0
    Debug.Print "GetFileName_ERR: " & Err.Description
'   return the last thing we got:
    If Len(sName) > 0 Then
        GetFileName = sName
    Else
'   else pass back what we got in:
        GetFileName = sFilePath
    End If
    

End Function


Public Sub TransferLists(lList1 As Control, lList2 As Control, Optional sAdd As String) '   takes the contents of one list and copies to another with optional additional string added
Dim i As Integer

On Error GoTo Transferlists_ERR

    lList2.Clear
    For i = 0 To lList1.ListCount - 1
        If sAdd <> "" Then
            lList2.AddItem lList1.List(i) & " " & sAdd & " "
        Else
            lList2.AddItem lList1.List(i)
        End If
    Next


Exit Sub

Transferlists_ERR:
Debug.Print "TransferLists_ERR:- " & Err.Description

End Sub
Public Function RemoveExtension(ByVal sFile As String) As String
'   takes a filename and removes the extension:

Dim i As Integer
Dim s As String
Dim bReplaceFinalQuote As Boolean
Dim sLastQuoteChar As String

On Error GoTo RemoveExtension_ERR

    bReplaceFinalQuote = (Right(Trim(sFile), 1) = Chr(39) Or Right(Trim(sFile), 1) = Chr(34))
    If bReplaceFinalQuote Then
        sLastQuoteChar = Right(Trim(sFile), 1)
    End If
    
    For i = Len(sFile) To 1 Step -1
        s = Mid(sFile, i, 1)
        If s = "." Then Exit For
    Next
    
    If i < 1 Then
        RemoveExtension = sFile
    Else
        RemoveExtension = Mid(sFile, 1, Len(sFile) - (Len(sFile) - i + 1))
        If bReplaceFinalQuote Then
            RemoveExtension = Trim(RemoveExtension) & sLastQuoteChar
        End If
    End If

    Exit Function
    
RemoveExtension_ERR:
    Debug.Assert 0
    Debug.Print "RemoveExtension_ERR: " & Err.Description

End Function


Public Function RemoveQuotes(ByVal sTempExp) As String
'   if there are quotes or double quotes around the passed in expression,
'   this function returns the expression without them.........

On Error GoTo RemoveQuotes_ERR
    sTempExp = Trim(sTempExp)
    RemoveQuotes = sTempExp
    If sTempExp <> Chr(34) And sTempExp <> Chr(39) Then
        If (Left(Trim(sTempExp), 1) = Chr(34) Or Left(Trim(sTempExp), 1) = Chr(39)) _
        Or (Right(Trim(sTempExp), 1) = Chr(34) Or Right(Trim(sTempExp), 1) = Chr(39)) Then
            
            If Left(Trim(sTempExp), 1) = Chr(34) Or Left(Trim(sTempExp), 1) = Chr(39) Then
                sTempExp = Mid(sTempExp, 2)
            End If
            
            If Right(Trim(sTempExp), 1) = Chr(34) Or Right(Trim(sTempExp), 1) = Chr(39) Then
                sTempExp = Mid(sTempExp, 1, Len(sTempExp) - 1)
            End If
            
            RemoveQuotes = sTempExp
        Else
            RemoveQuotes = sTempExp
        End If
    Else
        RemoveQuotes = ""
    End If

    Exit Function
    
RemoveQuotes_ERR:
    Debug.Assert 0
    Debug.Print "RemoveQuotes_ERR: " & Err.Description


End Function

Public Function RemoveTableFromPath(sPath As String) As String
'   returns the path minus the file name:
'   ie. returns "c:\temp" from "c:\temp\table.dbf"

Dim i As Integer
Dim s As String
Dim bReplaceFinalQuote As Boolean
Dim sLastQuoteChar As String

On Error GoTo RemoveTableFromPath_ERR
    
    bReplaceFinalQuote = (Right(Trim(sPath), 1) = Chr(39) Or Right(Trim(sPath), 1) = Chr(34))
    If bReplaceFinalQuote Then
        sLastQuoteChar = Right(Trim(sPath), 1)
    End If
    
    For i = Len(sPath) To 1 Step -1
        s = Mid(sPath, i, 1)
        If s = "\" Then Exit For
    Next
    
    If i > 1 Then
        RemoveTableFromPath = Mid(sPath, 1, i - 1)
        If bReplaceFinalQuote Then
            RemoveTableFromPath = Trim(RemoveTableFromPath) & sLastQuoteChar
        End If
    End If
    
    Exit Function
    
RemoveTableFromPath_ERR:
    Debug.Assert 0
    Debug.Print "RemoveTableFromPath_ERR: " & Err.Description
    

End Function
Public Function RemoveFileFromPath(sPath As String) As String
'   returns the path minus the file name:
'   ie. returns "c:\temp" from "c:\temp\table.dbf"

Dim i As Integer
Dim s As String
Dim bReplaceFinalQuote As Boolean
Dim sLastQuoteChar As String

On Error GoTo RemoveTableFromPath_ERR
    
    bReplaceFinalQuote = (Right(Trim(sPath), 1) = Chr(39) Or Right(Trim(sPath), 1) = Chr(34))
    If bReplaceFinalQuote Then
        sLastQuoteChar = Right(Trim(sPath), 1)
    End If
    
    For i = Len(sPath) To 1 Step -1
        s = Mid(sPath, i, 1)
        If s = "\" Then Exit For
    Next
    
    If i > 1 Then
        RemoveFileFromPath = Mid(sPath, 1, i - 1)
        If bReplaceFinalQuote Then
            RemoveFileFromPath = Trim(RemoveFileFromPath) & sLastQuoteChar
        End If
    End If
    
    Exit Function
    
RemoveTableFromPath_ERR:
    Debug.Assert 0
    Debug.Print "RemoveTableFromPath_ERR: " & Err.Description
    

End Function


Public Sub ReturnWOEndNull(ByRef sString As String)
Dim i As Integer
Dim s As String
'   return a string up to its terminating null character

On Error GoTo ReturnWOEndNull_ERR

    For i = 1 To Len(sString)
        s = Mid(sString, i, 1)
        If s = Chr(0) Then
            Exit For
        End If
    Next
        
    sString = Mid(sString, 1, i - 1)
    
    Exit Sub
    
ReturnWOEndNull_ERR:
    Debug.Assert 0
    Debug.Print "ReturnWOEndNull_ERR: " & Err.Description
    

End Sub

Public Function ReturnPathWOFinalSlash(ByRef sPath As String) As String
'** IE. RETURN "C:\TEMP" FROM "C:\TEMP\"
Dim i As Integer
Dim s As String
Dim iEnd As Integer

On Error GoTo ReturnPathWOFinalSlash_ERR
    
    iEnd = Len(sPath)
    For i = Len(sPath) To 1 Step -1
        s = Mid(sPath, i, 1)
        If s = "\" Then
            iEnd = i - 1
        Else
            Exit For
        End If
    Next
    
    ReturnPathWOFinalSlash = Mid(sPath, 1, iEnd)

    Exit Function
    
ReturnPathWOFinalSlash_ERR:
    Debug.Assert 0
    Debug.Print "ReturnPathWOFinalSlash_ERR: " & Err.Description

End Function


Public Function HasDriveInPath(sPath As String) As Boolean
On Error GoTo HasDrive_ERR
Dim s As String
Dim i As Integer

'   look for drive specification in Data File; if not use current directory:
    For i = 0 To Len(sPath) - 2
        s = Mid(sPath, i + 1, 2)
        If s = ":\" Then
            HasDriveInPath = True
            Exit Function
        End If
    Next

    Exit Function

HasDrive_ERR:
    Debug.Assert 0
    Debug.Print "HasDrive_ERR: " & Err.Description
    Resume Next
    
End Function


